#include "cv.h"
#include "highgui.h"
#include <stdio.h>
#include <math.h>


#ifndef _MAX_PATH
#define _MAX_PATH 260
#endif

#define GUI 1

#define USE_XML 1


#if not GUI
int nop() {return 0;};
#define cvShowImage(x,y) cvSaveImage(x ".png",y)
#define cvWaitKey(x) nop()
#define cvNamedWindow(x,y) nop()
#endif


//road map mannual marking
int  create_road_map( char* image_file_name, char *test_file_name )
{
    IplImage*  img = 0;
    
    fprintf(stderr,"Loading %s\n",image_file_name);
    img = cvLoadImage( image_file_name, 1 );
    if(img==NULL) 
    {
      printf("NOT OK: Could not load image: %s!\n",image_file_name);
      exit(0);
    }
  
    FILE *Handle=fopen(test_file_name,"r");
    if(Handle==NULL)
    {
      printf("NOT OK: Could not load test case: %s!\n",image_file_name);
      exit(0);
    }

    unsigned int x,y,r,g,b;
    char op[100]="eq";

    while(fscanf(Handle,"<point x=\"%d\" y=\"%d\" op=\"eq\" color=\"#%2X%2X%2X\"/>\n",&x,&y,&r,&g,&b)>1)
    {
       unsigned char br=img->imageData[y*img->widthStep+3*x+2];
       unsigned char bg=img->imageData[y*img->widthStep+3*x+1];
       unsigned char bb=img->imageData[y*img->widthStep+3*x+0];
       if(!strcmp(op,"eq"))
       { 
         if(r==br && g==bg && b==bb)
           printf("OK\n");
         else
           printf("NOT OK: Color doesn´t match\n");
       }
       else
       {
         printf("Scanning point (%d,%d) %d,%d,%d...\n",x,y,r,g,b);
         printf("Color there: %d,%d,%d (should be equal)\n",br,bg,bb);

         printf("NOT OK: Unknown Operation\n");
       }

    }
    fclose(Handle);

    cvReleaseImage( &img );

    return 1;
}

// usage: picking.exe <args> 
int main( int argc, char **argv )
{
    int mode = 0;
    if( argc < 2 )
    {
        printf( "Usage: %s\n  <filename.png> <filename.xml>\n", argv[0] );
        return 0;
    }

    char* image_file_name = 0;
    create_road_map( argv[1],argv[2] );

    return 0;
}

